<svelte:window on:keydown="checkForExit(event)" />

<div class="settings-modal-holder">
  <div class="exit-button" on:click="$set({modal: null})">
    &times;
  </div>
  <div class="settings-modal-inner">
    <div class="settings-modal-categories">
      {#each tabs as tabName, index (tabName)}
      <div class="settings-category" on:click="set({selected: tabName})" class:selected="selected == tabName">
        {tabName.toUpperCase()}
      </div>
      {/each}
    </div>
    <div class="settings-modal-content">
      <slot />
    </div>
  </div>
</div>

<script>
  export default {
    computed: {
      selected({tabs}) {
        return tabs[0];
      }
    },
    methods: {
      checkForExit(event) {
        const keyCode = event.which || event.keyCode;
        if (keyCode == 27) {
          this.store.set({modal: null});
        }
      }
    }
  };
</script>

<style>
  @keyframes jumpin {
    0% {
      opacity: 0;
    }
    100% {
      opacity: 1;
    }
  }

  .settings-modal-holder {
    opacity: 1;
    animation: jumpin 0.1s ease-out;
    z-index: 9999;
    height: 100vh;
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: #202224;
  }

  .settings-modal-inner {
    padding: 10vh 15vw 0 10vw;
    max-height: 90vh;
    overflow: auto;
    display: flex;
  }

  .settings-modal-categories {
    width: 10vw;
  }

  .settings-modal-content {
    flex-grow: 1;
    margin-left: 2vw;
  }

  .settings-category {
    border-radius: 4px;
    background-color: #2f3336;
    color: #bbb;
    padding: 6px 4px 6px 1.25em;
    font-size: 0.9em;
    font-weight: 700;
  }

  .settings-category:not(.selected) {
    cursor: pointer;
  }

  .settings-category:not(:last-child) {
    margin-bottom: 4px;
  }

  .settings-category:hover,
  .settings-category.selected {
    background-color: #4b4f52;
  }

  .exit-button {
    padding: 2px;
    position: absolute;
    top: 32px;
    right: 48px;
    width: 1.5em;
    text-align: center;
    height: 1.5em;
    font-size: 1.5em;
    cursor: pointer;
    color: #4b4f52;
    border-radius: 100%;
    border: #4b4f52 solid 2px;
    font-weight: 900;
    transition: linear 0.05s;
    line-height: 1.5em;
  }

  .exit-button:hover {
    background-color: #313336;
    border-color: #fff;
    color: #fff;
  }
</style>
